{
  Author: bobobubo, http://www.ujezdsky.cz
}

const
{$INCLUDE VerifAtrbVisual.lib.pas}
{$INCLUDE VerifBitmap.lib.pas}

{$INCLUDE FinalVerification.config.pas}
{$INCLUDE Separ.lib.pas}
{$INCLUDE Visual.lib.pas}

function PluginVisual(value: string): string;

var
  visual_NOTEp, visual_ATRBp, datum, note: string;
  atr: array [1..10] of string;
  geo : TGeo;
  i, lenstr, icowidth: integer;
  icoout, bmpMystery, bmpDate, bmpNote: TBitmap;

begin
    visual_ATRBp := visual_ATRB;
    if not((visual_ATRBp = '0') or (visual_ATRBp = '1')) then visual_ATRBp := '1';
    visual_NOTEp := visual_NOTE;
    if not((visual_NOTEp = '0') or (visual_NOTEp = '1') or (visual_NOTEp = '2') or (visual_NOTEp = '3')) then visual_NOTEp := '1';

    geo := TGeo.Create;
    geo.LoadByGC (Geoget_VisID);
    lenstr:=length(value);

    bmpMystery := TBitMap.Create;
    bmpDate := TBitMap.Create;
    bmpNote := TBitMap.Create;
    icoout := TBitmap.Create;
    icowidth := 68;

    if value <> ''then begin
      datum := separDate(value);
      note := separNote(value);
      if (note = '') or (visual_NOTEp = '0') then icowidth := icowidth - 16;
    end;

    BitmapStringToBitmap(icoNote, bmpNote);
    if (pos('unverified-',value)) > 0 then BitmapStringToBitmap(unverified, bmpMystery);
    if (pos('listing-',value)) > 0 then BitmapStringToBitmap(listing, bmpMystery);
    if (pos('otherwise-',value)) > 0 then BitmapStringToBitmap(otherwise, bmpMystery);
    if (pos('evince-',value)) > 0 then BitmapStringToBitmap(evince, bmpMystery);
	  if (pos('geocheck-',value)) > 0 then BitmapStringToBitmap(geocheck, bmpMystery);
    if (pos('geochecker-',value)) > 0 then BitmapStringToBitmap(geochecker, bmpMystery);
    if (pos('komurka-',value)) > 0 then BitmapStringToBitmap(komurka, bmpMystery);
    if (pos('certitudes-',value)) > 0 then BitmapStringToBitmap(certitudes, bmpMystery);
    if (pos('finar-',value)) > 0 then BitmapStringToBitmap(finar, bmpMystery);
    if (pos('gccounter-',value)) > 0 then BitmapStringToBitmap(gccounter, bmpMystery);
    if (pos('hermansky-',value)) > 0 then BitmapStringToBitmap(hermansky, bmpMystery);

    atr[1] := atrbA; atr[2] := atrbB;

    for i := 1 to 2 do begin
        case Uppercase(cfg_ICOATRIBUT[i]) of
             'A': atr[i] := atrbA;
             'B': atr[i] := atrbB;
             'C': atr[i] := atrbC;
             'D': atr[i] := atrbD;
             'E': atr[i] := atrbE;
             'F': atr[i] := atrbF;
             'G': atr[i] := atrbG;
             'H': atr[i] := atrbH;
             'I': atr[i] := atrbI;
             'J': atr[i] := atrbJ;
             'K': atr[i] := atrbK;
             'L': atr[i] := atrbL;
             'M': atr[i] := atrbM;
             'N': atr[i] := atrbN;
             'O': atr[i] := atrbO;
             'P': atr[i] := atrbP;
        end;
    end;

    if (copy(value,1,1)) = '@' then BitmapStringToBitmap(atr[1], bmpDate);
    if (copy(value,1,1)) = '#' then BitmapStringToBitmap(atr[2], bmpDate);
    if ((copy(value,1,1)) = '-') or (visual_ATRBp = '0') then begin
       BitmapStringToBitmap(empty, bmpDate);
       if (visual_FIX = '0') or ((visual_FIX = '1') and (visual_ATRBp='0')) then icowidth := icowidth - 16;
    end;

    try
       BitmapStringToBitmap(empty, icoout);
       icoout.width := icowidth; icoout.height := 16;
       icoout.Canvas.Draw(1, 0, bmpMystery);
       if visual_ATRBp = '1' then icoout.Canvas.Draw(36, 0, bmpDate);
         if ((length(note)) > 0) and ( (visual_NOTEp = '1') or (visual_NOTEp = '3')) then begin
            icoout.Canvas.Draw(icowidth-16, 0, bmpNote);
         end;
       geoget_visdata := BitmapToDecodedBitmapString(icoout);

    finally
           bmpMystery.Free;
           bmpDate.Free;
           bmpNote.Free;
           icoout.Free;
    end;

    if (visual_NOTEp = '0') or (visual_NOTEp = '1') then note := '';
    if visual_DATE = '0' then datum := '';
       Result := note + ' ' + datum;

end;
//******************************************************************************